#include <lwrpc_internal.h>
#include <lwrpc.h>
#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>

#define WAIT_COUNT 2
#define YIELD_TIME	(0)

#define A0	   
#define A1	    arg[0]
#define A2	 A1,arg[1]
#define A3	 A2,arg[2]
#define A4	 A3,arg[3]
#define A5	 A4,arg[4]
#define A6	 A5,arg[5]
#define A7	 A6,arg[6]
#define A8	 A7,arg[7]
#define A9	 A8,arg[8]
#define A10	 A9,arg[9]
#define A11	A10,arg[10]
#define A12	A11,arg[11]
#define A13	A12,arg[12]
#define A14	A13,arg[13]
#define A15	A14,arg[14]
#define A16	A15,arg[15]
#define A17	A16,arg[16]
#define A18	A17,arg[17]

#define I00       
#define I01         iarg[0]
#define I02      I01,iarg[1]
#define I03      I02,iarg[2]
#define I04      I03,iarg[3]
#define I05      I04,iarg[4]
#define I06      I05,iarg[5]
#define I07      I06,iarg[6]
#define I08      I07,iarg[7]
#define I09      I08,iarg[8]
#define I10      I09,iarg[9]

#define D00
#define D01         darg[0]
#define D02      D01,darg[1]
#define D03      D02,darg[2]
#define D04      D03,darg[3]
#define D05      D04,darg[4]
#define D06      D05,darg[5]
#define D07      D06,darg[6]
#define D08      D07,darg[7]
#define D09      D08,darg[8]
#define D10      D09,darg[9]

#define DO_CASE(x)			\
	case x:				\
	{				\
		rpc->work(A##x);	\
		break;			\
	}


#define build_stack(mem, rpc, whicharg)							\
{											\
	int i;										\
	for (i=0; i<rpc->narg; i++) {							\
		if (rpc->callway[i] == CALL_BY_VAL) {					\
			int typesize;							\
			MPI_Type_size(rpc->dtype[i], &typesize);			\
			switch (typesize) {						\
			case 4:								\
				memcpy(mem, &rpc->whicharg[i], sizeof(VIRT_ADDR));	\
				mem += sizeof(VIRT_ADDR);				\
				break;							\
			case 8:								\
				memcpy(mem, &rpc->whicharg[i], sizeof(INT64));		\
				mem += sizeof(INT64);					\
				break;							\
			default:							\
				Error("typesize not 4 or 8!");				\
				break;							\
			}								\
		}									\
		else if (rpc->callway[i] == CALL_BY_COP) {				\
			void *addr = &rpc->whicharg[i];					\
			memcpy(mem, &addr, sizeof(VIRT_ADDR));				\
			mem += sizeof(VIRT_ADDR);					\
		}									\
		else {									\
			memcpy(mem, &rpc->whicharg[i], sizeof(VIRT_ADDR));		\
			mem += sizeof(VIRT_ADDR);					\
		}									\
	}										\
}


static void core_execution_c (lwrpc_t *rpc)
{
	INT64 stack[32];
	INT64 *arg = stack;
	char *mem = (char *)arg;
	double darg[18] = {0};              
	long iarg[18] = {0};   
	int mynode = lwrpc_node_id();
	int i, n_iarg = 0, n_darg = 0;      

	if (rpc->rpc_type != 2)
	{

	for (i = 0; i < rpc->narg; i++) {    
		if ((rpc->callway[i] == CALL_BY_VAL) && (rpc->dtype[i] == MPI_DOUBLE)) {
			if (mynode == rpc->homenode)
				memcpy(&darg[n_darg], &rpc->localarg[i], sizeof(double));
			else
				memcpy(&darg[n_darg], &rpc->temparg[i], sizeof(double));
			n_darg++;
		}
                else if (rpc->callway[i] == CALL_BY_COP) {
			void *addr;
			if (mynode == rpc->homenode)
				addr = &rpc->localarg[i];
			else
				addr = &rpc->temparg[i];
			memcpy(&iarg[n_iarg], &addr, sizeof(VIRT_ADDR));
			n_iarg++;
                }                                  
		else {      
			if (mynode == rpc->homenode)
				memcpy(&iarg[n_iarg], &rpc->localarg[i], sizeof(VIRT_ADDR));
			else
				memcpy(&iarg[n_iarg], &rpc->temparg[i], sizeof(VIRT_ADDR));
			n_iarg++;
		}
	}

	if (n_darg == 0) rpc->work(I10);
	if (n_darg == 1) rpc->work(D01,I10);
	if (n_darg == 2) rpc->work(D02,I10);
	if (n_darg == 3) rpc->work(D03,I10);
	if (n_darg == 4) rpc->work(D04,I10);
	if (n_darg == 5) rpc->work(D05,I10);
	if (n_darg == 6) rpc->work(D06,I10);
	if (n_darg == 7) rpc->work(D07,I10);
	if (n_darg == 8) rpc->work(D08,I10);
	if (n_darg == 9) rpc->work(D09,I10);
	if (n_darg == 10) rpc->work(D10,I10);

	}
	else
	{
		arg = rpc->localarg;

	switch (rpc->narg){
	DO_CASE(0);
	DO_CASE(1);
	DO_CASE(2);
	DO_CASE(3);
	DO_CASE(4);
	DO_CASE(5);
	DO_CASE(6);
	DO_CASE(7);
	DO_CASE(8);
	DO_CASE(9);
	DO_CASE(10);
	DO_CASE(11);
	DO_CASE(12);
	DO_CASE(13);
	DO_CASE(14);
	DO_CASE(15);
	DO_CASE(16);
	DO_CASE(17);
	DO_CASE(18);
	default:
		Error("rpc function with more than 18 arguments..!");
		break;
	}

	}
}


static void core_execution_f (lwrpc_t *rpc)
{
	VIRT_ADDR fargs[MAX_LWRPC_ARGS], *arg = fargs;
	int i;

	if (lwrpc_node_id() == rpc->homenode) {
		for (i=0; i<rpc->narg; i++) {
			if (rpc->callway[i] == CALL_BY_VAL) {
				fargs[i] = (VIRT_ADDR) &rpc->localarg[i];      /* pointer to the private copy (FORTRAN: by reference) */
			}
			else {
				fargs[i] = rpc->localarg[i];
			}
		}
	}
	else {
		for (i=0; i<rpc->narg; i++) {
			if (rpc->callway[i] == CALL_BY_VAL) {
				fargs[i] = (VIRT_ADDR) &rpc->temparg[i];
			}
			else {  /* CALL_BY_VAD */
				fargs[i] = rpc->temparg[i];
			}
		}
	}

	switch (rpc->narg){
	DO_CASE(0);
	DO_CASE(1);
	DO_CASE(2);
	DO_CASE(3);
	DO_CASE(4);
	DO_CASE(5);
	DO_CASE(6);
	DO_CASE(7);
	DO_CASE(8);
	DO_CASE(9);
	DO_CASE(10);
	DO_CASE(11);
	DO_CASE(12);
	DO_CASE(13);
	DO_CASE(14);
	DO_CASE(15);
	DO_CASE(16);
	DO_CASE(17);
	DO_CASE(18);
	default:
		Error("rpc function with more than 18 arguments..!");
		break;
	}
}

void _lwrpc_reset_statistics()
{
	memset(created, 0, MAX_CPUS*sizeof(unsigned long));
	memset(executed, 0, MAX_CPUS*sizeof(unsigned long));
}

void _lwrpc_print_statistics()
{
	unsigned int i;
	unsigned long total_created = 0, total_executed = 0;
	unsigned long total_created2 = 0, total_executed2 = 0;

	for (i = 0; i < kthreads; i++) {
		total_created += created[i];
		total_executed += executed[i];
		total_created2 += created2[i];
		total_executed2 += executed2[i];
	}

	printf("[%2d] created = %-3ld+%3ld = %3ld, executed %-3ld+%3ld = %3ld:(", lwrpc_node_id(), 
		total_created, total_created2, total_created + total_created2,
		total_executed, total_executed2, total_executed + total_executed2);
	for (i = 0; i < kthreads-1; i++) {
		printf("%-3ld+%3ld=%3ld,", executed[i], executed2[i], executed[i]+executed2[i]); fflush(0);
	}
	printf("%-3ld+%3ld=%3ld)\n", executed[i], executed2[i], executed[i]+executed2[i]); fflush(0);
}

lwrpc_t *_lwrpc_self()
{
	return (lwrpc_t *) (uth_getarg(uth_self()));
}

int _lwrpc_getlevel()
{
	return _lwrpc_self()->level;
}

void _lwrpc_depadd (lwrpc_t * rpc, int ndeps)
{
	_lock_acquire(&rpc->lock);
	rpc->ndep += ndeps;
	_lock_release(&rpc->lock);
}

static void _lwrpc_end (void)
{
	int finalized = 0;

	MPI_Finalized(&finalized);
	if (finalized == 1) {
		_lwrpc_stats();
		_exit(0);
	}
	
	appl_finished++;
	if (lwrpc_num_nodes() > 1) {    /* notify the rest nodes that this node has finished */
		terminate_workers();
	}

	if (execution_mode == MODE_MS) {
	}
	else {
		if (!package_suspended) {
			while (appl_finished < tobe_finished) lwrpc_yield();
		}
	}

	_lwrpc_md_end ();
}

static void _lwrpc_switch (lwrpc_t * newrpc, lwrpc_t * oldrpc, int action);

static void _lwrpc_execute (void * arg)
{
	lwrpc_t * rpc = (lwrpc_t *) arg;
	unsigned long vp = rpc->vp_id;

#ifdef LWRPC_STATS
	if (rpc->rpc_type == 1) {
		if (rpc->level == 1)
			executed[vp]++;
		else
			executed2[vp]++;
	}
#endif

	if (rpc->c_routine == 1)
		core_execution_c(rpc);
	else
		core_execution_f(rpc);

	if (rpc->work == entry_routine) {	/* entry_routine != NULL */
		_lwrpc_end();
	}

	vp = rpc->vp_id;
	cleanup_rpc[vp][0] = rpc;
	_lwrpc_switch(scheduler_rpc[vp], rpc, EXIT_PREV);
}

static void _lwrpc_switch (lwrpc_t * newrpc, lwrpc_t * oldrpc, int action)
{
	newrpc->vp_id = oldrpc->vp_id;

	if (newrpc->uth_handler == NULL)
		newrpc->uth_handler = uth_create(_lwrpc_execute, newrpc);

	if (action == SAVE_PREV)
		uth_switchto_ex(newrpc->vp_id, oldrpc->uth_handler, newrpc->uth_handler);
	else
		uth_switchto_ex(newrpc->vp_id, NULL, newrpc->uth_handler);
}

int _lwrpc_block (void)
{
	lwrpc_t *rpc = _lwrpc_self();
	int self = rpc->vp_id;

	_lock_acquire (&rpc->lock);
	--rpc->ndep;
	_lock_release (&rpc->lock);
	if (rpc->ndep==0) {
		return 1;
	}

	cleanup_rpc[self][0] = NULL;
	_lwrpc_switch(scheduler_rpc[self], rpc, SAVE_PREV);
	return 0;
}

void _lwrpc_yield()
{
	lwrpc_t *rpc = _lwrpc_self();
	int self = rpc->vp_id;

	cleanup_rpc[self][0] = NULL;
	yield_rpc[self]= rpc;
	_lwrpc_switch(scheduler_rpc[self], rpc, SAVE_PREV);
}

void _lwrpc_set_work_routine(lwrpc_t *rpc, void (*work)())
{
	rpc->work = work;
}

int _lwrpc_depsatisfy (lwrpc_t * rpc)
{
    int deps;

    _lock_acquire (&rpc->lock);
    deps = --rpc->ndep;
    _lock_release (&rpc->lock);
    return !deps;
}

void _lwrpc_stats (void)
{
#ifdef LWRPC_STATS
	_lwrpc_print_statistics();
#endif
}

extern MPI_Comm comm_out;

void _lwrpc_opt (int argc, char *argv[])
{
	int largc = argc;
	char **largv = argv;
	char *llargv = "";
	int requested, provided;
	int initialized = 0;
	char *s;
	int val;
	int stackpages = 0;

	requested = MPI_THREAD_MULTIPLE;

	if (argc == 0) largv = (char **) &llargv;
	
	MPI_Initialized(&initialized);
	if (initialized == 0) {
		MPI_Init_thread(&largc, &largv, requested, &provided);
	}
	else {
		MPI_Query_thread(&provided);
	}

	if (provided != MPI_THREAD_MULTIPLE)
		thread_safe = 0;
	else
		thread_safe = 1;

#ifdef NONBLOCKING
	non_blocking = 1;
#else
	non_blocking = 0;
	if (!thread_safe) non_blocking = 1;
#endif

	master_noworker = 0;
	s = (char *) getenv("LWRPC_MASTER_NOWORKER");
	if (s != 0)
		master_noworker = val;

#ifdef BLOCK_IDLE_THREADS
	block_idle_threads = 1;
#else
	block_idle_threads = 0;
#endif

	kthreads = LWRPC_DEF_CPUS;
	s = (char *) getenv("LWRPC_WORKERS");
	if (s != 0 && sscanf(s, "%d", &val) == 1 && val > 0)
		kthreads = val;

	stackpages = LWRPC_DEF_STACKPAGES;
	s = (char *) getenv("LWRPC_STACKPAGES");
	if (s != 0 && sscanf(s, "%d", &val) == 1 && val > 0)
		stackpages = val;

	thread_stacksize = stackpages*getpagesize();
	if (thread_stacksize<1) thread_stacksize = 0;

	MPI_Comm_rank(MPI_COMM_WORLD,&mpi_rank);
	MPI_Comm_size(MPI_COMM_WORLD,&mpi_nodes);

	if (mpi_rank == 0) {
		printf("The MPI implementation IS%s thread safe!\n", (thread_safe)? "": " NOT"); 
		if (non_blocking && thread_safe)
			printf("Remark: non-blocking calls are not necessary in thread-safe MPI implementations\n");

		s = (char *) getenv("LWRPC_MASTER_WORKERS");
		if (s != 0 && sscanf(s, "%d", &val) == 1 && val > 0)
			kthreads = val;
	}

	MPI_Comm_dup(MPI_COMM_WORLD, &comm_out);
	MPI_Barrier(MPI_COMM_WORLD);

	_lwrpc_comm_pre_init();
}


void _lwrpc_env_init(void)
{
	uth_init(thread_stacksize);
	
	_lock_init(&datalock);
	_lock_init(&reductionlock);
	_lock_init(&commlock);
	rq_init ();
	_lwrpc_md_init();
	_lwrpc_comm_init();

	if (entry_routine == NULL) 
		if ((execution_mode == MODE_SPMD)||(lwrpc_node_id() == 0))
			atexit(_lwrpc_end);
}


lwrpc_t *get_next_lwrpc(int self)
{
	int self_node = lwrpc_node_id();
	int nnodes = lwrpc_num_nodes();
	lwrpc_t *rpc_next = NULL;
	int vp;
	int node;
	
	rpc_next = lwrpc_i_pq_dequeue ();
	if (rpc_next == NULL) {
		rpc_next = lwrpc_i_lrq_dequeue (self);
		if (rpc_next == NULL)
			rpc_next = lwrpc_i_rq_dequeue();
		vp = (self + 1) % kthreads;
		while ((rpc_next == NULL) && (vp != self)) {
			rpc_next = lwrpc_i_lrq_dequeue(vp);
			vp = (vp + 1) % kthreads;
		}
	}

	return rpc_next;
}

void scheduler_loop ()
{
	int wait_count;
	int self = lwrpc_i_worker_id();
	register lwrpc_t * rpc_next = NULL;
	lwrpc_t *rpc;

	while (1) {
		if (yield_rpc[self] != NULL) {
			lwrpc_to_i_rq_end(yield_rpc[self]);
			yield_rpc[self] = NULL;
		}

		rpc_next = NULL;
		rpc = cleanup_rpc[self][0];
		if (rpc != NULL) {
			if (rpc->inter_node == 1) {
				if (rpc->homenode != lwrpc_node_id()) {
					send_descriptor(rpc->homenode, rpc, LWRPC_ANSWER);
				}
				else {
					if ((rpc->parent) && (_lwrpc_depsatisfy(rpc->parent))) {
						if (rpc->parent->uth_handler == NULL) {
                               				if (rpc->parent->inter_node == 1)
                               					lwrpc_to_i_rq(rpc->parent);
							else
                                    				lwrpc_to_i_pq(rpc->parent);
						}
						else {
							lwrpc_to_i_pq(rpc->parent);
						}
					}
				}
			}
			else 	{
				if ((rpc->parent) && (_lwrpc_depsatisfy (rpc->parent))) {
					if (rpc->parent->uth_handler == NULL) {
						if (rpc_next==NULL) rpc_next = rpc->parent;
						else lwrpc_to_i_pq (rpc->parent);
					}
					else {
						if ((rpc_next==NULL)&&(rpc->parent->vp_id == self)) rpc_next = rpc->parent;
						else lwrpc_to_i_pq (rpc->parent);
					}
				}
			}

			if (rpc->uth_handler != NULL) uth_delete(rpc->uth_handler);
			_lwrpc_put_reused_desc(rpc);
		}

		if (rpc_next==NULL) {
			rpc_next = get_next_lwrpc(self);

			while (rpc_next==NULL) {
				if (appl_finished == tobe_finished) _lwrpc_md_end();
				thread_wait();
				if (appl_finished == tobe_finished) _lwrpc_md_end();
				wait_count = WAIT_COUNT;
				while (--wait_count) { sched_yield();}
				rpc_next = get_next_lwrpc(self);
			}
		}
		_lwrpc_switch (rpc_next, scheduler_rpc[self], SAVE_PREV);
	}
}


